@echo off
rem
rem  Uses SED to generate the module definition file for linking into
rem  a DLL, and the rsxdll.h header that tricks DLL variable references
rem  into working with RSXNT.
rem

echo Scanning for global symbols...
gcc -E -I. -I./include -dD -DSCAN_EXPORT -o _expdef.tmp src/dime.c
echo ; generated by fixdll.bat > _dime.def
echo EXPORTS >> _dime.def
sed -n -e "s/^ *_dime_scanex_dll_code  *\**\(.*\)_dll.*/    \1/p" _expdef.tmp > _expdef1.tmp
sed -n -e "s/^ *_dime_scanex_dll_data  *\**\(.*\)_dll.*/    \1 DATA/p" _expdef.tmp >> _expdef1.tmp
sort _expdef1.tmp > _expdef2.tmp
sed -e "p" -e "=" -e "d" _expdef2.tmp > _expdef3.tmp
sed -e "N" -e "s/\n/ @/" -e "s/DATA \(.*\)/\1 DATA/" _expdef3.tmp >> _dime.def

echo Generating lib\msvc\dime.def...
copy _dime.def lib\msvc\dime.def > nul

echo Generating lib\mingw32\dime.def...
copy _dime.def lib\mingw32\dime.def > nul

echo Generating include\dime\rsxdll.h...
echo /* generated by fixdll.bat for RSXNT */ > include\dime\rsxdll.h
sed -n -e "s/^ *_dime_scanex_dll_data *\**\(.*\)_dll.*/#define \1 (*\1)/p" _expdef.tmp >> include\dime\rsxdll.h

rm _expdef.tmp _expdef1.tmp _expdef2.tmp _expdef3.tmp _dime.def

echo Done!