/*  ___  _
	|   \(_)_ __  ___
	| |) | | '  \/ -_)
	|___/|_|_|_|_\___|

	dbool.c:
	Dialogf functions for editing booleans as check boxes.

	By Sven Sandberg

	See readme.txt for more information about Dime.


	int my_int;
	dialogf(..., "Description%bool[]", &my_int);
*/
#include <stdarg.h>
#include <allegro.h>

#ifdef FORTIFY
#include "fortify2.h"
#endif

#include "dime.h"
#include "dime/dimeint.h"



/* dialogf_create_bool:
*/
int dialogf_create_bool(DIALOG *d, char *desc, char *arg_text,
								dime_va_list_p args)
{
	DIME_UNUSED_ARG(desc);
	DIME_ASSERT(ugetc(arg_text) == 0,
					("No arguments must be given to %%bool"));

	d->proc = d_dime_check_proc;
	d->w = d->h = MAX(12, MIN(d->w, text_height(_dime_font)));
	d->dp3 = dime_va_arg_p(args, int *);
	return 0;
}



/* dialogf_store_bool:
*/
void dialogf_store_bool(DIALOG *d)
{
	*(int *)d->dp3 = (d->flags & D_SELECTED) ? TRUE : FALSE;
}



/* dialogf_reset_bool:
*/
void dialogf_reset_bool(DIALOG *d)
{
	d->flags = *(int *)d->dp3 ? D_SELECTED : 0;
}