/*  ___  _
	|   \(_)_ __  ___
	| |) | | '  \/ -_)
	|___/|_|_|_|_\___|

	dnothing.c:
	Dialogf functions for the %nothing format, which does nothing but
	displaying its description

	By Sven Sandberg

	See readme.txt for more information about Dime.


	dialogf(..., "%nothing[]");
*/
#include <stdarg.h>
#include <allegro.h>

#ifdef FORTIFY
#include "fortify2.h"
#endif

#include "dime.h"
#include "dime/dimeint.h"



/* dialogf_create_nothing:
*/
int dialogf_create_nothing(DIALOG *d, char *desc, char *arg_text,
									dime_va_list_p args)
{
	DIME_UNUSED_ARG(args);

	DIME_ASSERT(ugetc(arg_text) == 0,
					("No arguments must be given to %%nothing"));

	if (_dialogf_pass_index == 0) {
		d->w = 0;
		return 3;
	}
	else if (_dialogf_pass_index == 1) {
		/* Create description when we know where left edge of dialog is. */
		dialogf_create_desc(d, d->y, ustrdup(desc));
		d->x = _dime_dialog->x + dime_window_border_thickness;
		d->d1 = ALIGN_LEFT;
		return 2;
	}
	else
		return 0;
}