/*  ___  _
	|   \(_)_ __  ___
	| |) | | '  \/ -_)
	|___/|_|_|_|_\___|

	dstring.c:
	Dialogf functions for editing a text.

	By Sven Sandberg

	See readme.txt for more information about Dime.


	char name[1024];
	dialogf(..., "What's your name?%string[256]", name);
*/
#include <allegro.h>

#ifdef FORTIFY
#include "fortify2.h"
#endif

#include "dime.h"
#include "dime/dimeint.h"



/* dialogf_create_string:
*/
int dialogf_create_string(DIALOG *d, char *desc, char *arg_text,
								  dime_va_list_p args)
{
	int state;

	DIME_UNUSED_ARG(desc);

	/* Parse parameters. */
	state = dime_get_int_arg(&arg_text, &d->d1);
	DIME_ASSERT(state & DIME_ARG_READ,
					("No max length specified for %%string"));
	DIME_ASSERT(state & DIME_ARG_END,
					("Garbage found at end of format modifier for %%string: [%s]",
					 arg_text));

	d->proc = d_dime_edit_proc;
	d->h += 6;
	d->fg = _dime_text_color;
	d->bg = _dime_edit_field_color;
	d->dp = DIME_MALLOC(d->d1 * uwidth_max(U_CURRENT) + ucwidth(0), char);
	d->dp3 = dime_va_arg_p(args, char *);
	d->dp2 = _dime_font;

	return 0;
}



/* dialogf_store_string:
*/
void dialogf_store_string(DIALOG *d)
{
	/* As long as nothing on the way is buggy, we can assume that there are no
		more characters than specified. */
	ustrcpy((char *)d->dp3, (char *)d->dp);
}



/* dialogf_reset_string:
*/
void dialogf_reset_string(DIALOG *d)
{
	char *p1, *p2;
	int n, c;

	/* Copy at most (d->d1) characters to our temporary buffer. */
	p1 = (char *)d->dp3;
	p2 = (char *)d->dp;
	n = d->d1;
	for (c = ugetx(&p1); c && n--; c = ugetx(&p1))
		p2 += usetc(p2, c);
	usetc(p2, 0);

	d->d2 = ustrlen((char *)d->dp);
}